Async/Await 替代 Promise 的 6 个理由

  • 2020-09-15
  • 0
  • 0

Node.js 7.6 已经支持 async/await 了,而且非常值得尝试。

Async/Await 简介

  • async/await 是写异步代码的新方式,以前的方法有回调函数和Promise
  • async/await 是基于 Promise 实现的,它不能用于普通的回调函数。
  • async/await 与 Promise 一样,是非阻塞的。
  • async/await 使得异步代码看起来像同步代码,这正是它的魔力所在。

Async/Await 语法

示例中,getJSON 函数返回一个 promise,这个 promise 成功 resolve 时会返回一个 json 对象。我们只是调用这个函数,打印返回的 JSON 对象,然后返回”done”。

使用 Promise 是这样的:

const makeRequest = () =>
    getJSON().then(data => {
        console.log(data);
        return "done";
    });

makeRequest();

使用 Async/Await 是这样的:

const makeRequest = async () => {
    const res = await getJSON()
    console.log(res);
    return "done";
};

makeRequest();

它们有一些细微不同:

  1. 函数前面多了一个 async 关键字。await 关键字只能用在 async 定义的函数内。async 函数会隐式地返回一个 promise,该 promise 的 reosolve 值就是函数 return 的值。(示例中 reosolve 值就是字符串”done”)
  2. 第 1 点暗示我们不能在最外层代码中使用 await,因为不在 async 函数内

await getJSON() 表示这之后的语句会等到 getJSON 的 promise 成功 reosolve 之后再执行。

为什么 Async/Await 更好?

1. 简洁

由示例可知,使用 Async/Await 明显节约了不少代码。我们不需要写.then,不需要写匿名函数处理 Promise 的 resolve 值,也不需要定义多余的 data 变量,还避免了嵌套代码。这些小的优点会迅速累计起来,这在之后的代码示例中会更加明显。

2. 错误处理

Async/Await 让 try/catch 可以同时处理同步和异步错误。在下面的 promise 示例中,try/catch 不能处理 JSON.parse 的错误,因为它在 Promise 中。我们需要使用.catch,这样错误处理代码非常冗余。并且,在我们的实际生产代码会更加复杂。

const makeRequest = () => {
    try {
        getJSON().then(result => {
            // JSON.parse可能会出错
            const data = JSON.parse(result);
            console.log(data);
        });
        // 取消注释,处理异步代码的错误
        // .catch((err) => {
        //   console.log(err)
        // })
    } catch (err) {
        console.log(err);
    }
};

使用 async/await 的话,catch 能处理 JSON.parse 错误:

const makeRequest = async () => {
    try {
        // this parse may fail
        const data = JSON.parse(await getJSON());
        console.log(data);
    } catch (err) {
        console.log(err);
    }
};

3. 条件语句

下面示例中,需要获取数据,然后根据返回数据决定是直接返回,还是继续获取更多的数据。

const makeRequest = () => {
    return getJSON().then(data => {
        if (data.needsAnotherRequest) {
            return makeAnotherRequest(data).then(moreData => {
                console.log(moreData);
                return moreData;
            });
        } else {
            console.log(data);
            return data;
        }
    });
};

这些代码看着就头痛。嵌套(6 层),括号,return 语句很容易让人感到迷茫,而它们只是需要将最终结果传递到最外层的 Promise。

上面的代码使用 async/await 编写可以大大地提高可读性:

const makeRequest = async () => {
    const data = await getJSON();
    if (data.needsAnotherRequest) {
        const moreData = await makeAnotherRequest(data);
        console.log(moreData);
        return moreData;
    } else {
        console.log(data);
        return data;
    }
};

4. 中间值

你很可能遇到过这样的场景,调用 promise1,使用 promise1 返回的结果去调用 promise2,然后使用两者的结果去调用 promise3。你的代码很可能是这样的:

const makeRequest = () => {
    return promise1().then(value1 => {
        return promise2(value1).then(value2 => {
            return promise3(value1, value2);
        });
    });
};

如果 promise3 不需要 value1,可以很简单地将 promise 嵌套铺平。如果你忍受不了嵌套,你可以将 value 1 & 2 放进 Promise.all 来避免深层嵌套:

const makeRequest = () => {
    return promise1()
        .then(value1 => {
            return Promise.all([value1, promise2(value1)]);
        })
        .then(([value1, value2]) => {
            return promise3(value1, value2);
        });
};

这种方法为了可读性牺牲了语义。除了避免嵌套,并没有其他理由将 value1 和 value2 放在一个数组中。

使用 async/await 的话,代码会变得异常简单和直观。

const makeRequest = async () => {
    const value1 = await promise1();
    const value2 = await promise2(value1);
    return promise3(value1, value2);
};

5. 错误栈

下面示例中调用了多个 Promise,假设 Promise 链中某个地方抛出了一个错误:

const makeRequest = () => {
    return callAPromise()
        .then(() => callAPromise())
        .then(() => callAPromise())
        .then(() => callAPromise())
        .then(() => callAPromise())
        .then(() => {
            throw new Error("oops");
        });
};

makeRequest().catch(err => {
    console.log(err);
    // output
    // Error: oops at callAPromise.then.then.then.then.then (index.js:8:13)
});

Promise 链中返回的错误栈没有给出错误发生位置的线索。更糟糕的是,它会误导我们;错误栈中唯一的函数名为 callAPromise,然而它和错误没有关系。(文件名和行号还是有用的)。

然而,async/await 中的错误栈会指向错误所在的函数:

const makeRequest = async () => {
    await callAPromise();
    await callAPromise();
    await callAPromise();
    await callAPromise();
    await callAPromise();
    throw new Error("oops");
};

makeRequest().catch(err => {
    console.log(err);
    // output
    // Error: oops at makeRequest (index.js:7:9)
});

在开发环境中,这一点优势并不大。但是,当你分析生产环境的错误日志时,它将非常有用。这时,知道错误发生在 makeRequest 比知道错误发生在 then 链中要好。

6. 调试

最后一点,也是非常重要的一点在于,async/await 能够使得代码调试更简单。2 个理由使得调试 Promise 变得非常痛苦:

  1. 不能在返回表达式的箭头函数中设置断点。
  2. 如果你在.then 代码块中设置断点,使用 Step Over 快捷键,调试器不会跳到下一个.then,因为它只会跳过异步代码。
const makeRequest = () => {
    return callAPromise()
        .then(() => callAPromise())
        .then(() => callAPromise())
        .then(() => callAPromise())
        .then(() => callAPromise())
        .then(() => {
            throw new Error("oops");
        });
};

使用 await/async 时,你不再需要那么多箭头函数,这样你就可以像调试同步代码一样跳过 await 语句。

const makeRequest = async () => {
    await callAPromise();
    await callAPromise();
    await callAPromise();
    await callAPromise();
    await callAPromise();
    throw new Error("oops");
};

扩展

可查看英文版原文:6 Reasons Why JavaScript’s Async/Await Blows Promises Away

评论

还没有任何评论,你来说两句吧